#! /usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = __importDefault(require("commander"));
const fs_1 = require("fs");
const child_process_1 = require("child_process");
const core_1 = require("./core");
commander_1.default.version('1.4.0')
    .description('Search App paths with App Name')
    .arguments('[name ...]')
    .option('-f, --ini-file <path>', 'Append result to an ini-like file')
    .option('-c, --NPM-config', 'Set result to local NPM configuration')
    .parse(process.argv);
const show_log = commander_1.default.iniFile || commander_1.default.NPMConfig;
(() => __awaiter(void 0, void 0, void 0, function* () {
    if (show_log)
        console.time('Search');
    for (const name of commander_1.default.args) {
        const path = yield core_1.which(name);
        console.info((show_log || commander_1.default.args[1] ? `${name}=` : '') + path);
        if (commander_1.default.iniFile)
            fs_1.appendFileSync(commander_1.default.iniFile, `${name}=${path}\n`);
        else if (commander_1.default.NPMConfig)
            child_process_1.execSync(`npm set ${name} ${JSON.stringify(path)}`);
    }
    if (!show_log)
        return;
    console.info('--------------------');
    console.timeEnd('Search');
}))();
